#ifndef XMLTEXT_H
#define XMLTEXT_H

#include "text.h"

class crumb;
/*
class linea
    {
    public:
        int start;
        int end;
    };
*/


class XMLtext : public text
    {
    private:
        //token * Token;
        char * startElement;
        char * endElement;
        char * startAttributeName;
        char * endAttributeName;
        char * startValue;
        char * endValue;
        const char * ancestor; // if not null, restrict POS-tagging to elements that are offspring of ancestor
        const char * segment; // Optional segment delimiter. E.g. br: <br /> or s: <s> ... </s>
        const char * element; // if not null, analyse only element's attributes and/or PCDATA
        const char * PreTagAttribute; // if null, POS is PCDATA
        const char * POSAttribute; // Store POS in POSAttribute
        int wordAttributeLen;
        int PreTagAttributeLen;
        int POSAttributeLen;
        crumb * Crumbs;
        bool ClosingTag;
        bool WordPosComing;
        bool PreTagPosComing;
        bool POSPosComing;
    public:
        virtual const char * convert(const char * s);
        const char * wordAttribute; // if null, word is PCDATA
    public:
        bool analyseThis();
        token * getCurrentToken();
        void CallBackStartElementName();
        void CallBackEndElementName();
        void CallBackStartAttributeName();
        void CallBackEndAttributeNameInserting();
        void CallBackEndAttributeNameCounting();
        void CallBackStartValue();
        void CallBackEndValue();
        void CallBackEndTag();
        void CallBackEmptyTag();
        void CallBackNoMoreAttributes();
        XMLtext(
#if STREAM
            istream & fpi
#else
            FILE * fpi
#endif
           //,bool a_InputHasTags
           ,char * Iformat
           //,int keepPunctuation
           ,bool nice
           ,unsigned long int size
           //,bool treatSlashAsAlternativesSeparator
           ,bool XML
           ,const char * ancestor // if not null, restrict POS-tagging to elements that are offspring of ancestor
           ,const char * segment // Optional segment delimiter. E.g. br: <br /> or s: <s> ... </s>
           ,const char * element // analyse PCDATA inside elements
           ,const char * wordAttribute // if null, word is PCDATA
           ,const char * PreTagAttribute // Fetch pretagging from PreTagAttribute
           ,const char * POSAttribute // Store POS in POSAttribute
            );
        ~XMLtext(){}
        virtual void printUnsorted(
#if STREAM
            ostream & fpo
#else
            FILE * fpo            
#endif
            );
    };

#endif
